Main Page | Namespace List | Class Hierarchy | Alphabetical List | Compound List | File List | Namespace Members | Compound Members | File Members

# NullStore Class Reference

`#include <filters.h>`

Inheritance diagram for NullStore:

List of all members.

## Detailed Description

Definition at line 586 of file filters.h.

## ATTACHMENT
virtual bool | Attachable ()
| returns whether this object allows attachment
virtual BufferedTransformation * | AttachedTransformation ()
| returns the object immediately attached to this object or NULL for no attachment
virtual const BufferedTransformation * | AttachedTransformation () const
virtual void | Detach (BufferedTransformation *newAttachment=0)
| delete the current attachment chain and replace it with newAttachment
virtual void | Attach (BufferedTransformation *newAttachment)
| add newAttachment to the end of attachment chain
## Public Member Functions
| NullStore (unsigned long size=ULONG_MAX)
void | StoreInitialize (const NameValuePairs &parameters)
unsigned long | MaxRetrievable () const
| returns number of bytes that is currently ready for retrieval
unsigned int | TransferTo2 (BufferedTransformation &target, unsigned long &transferBytes, const std::string &channel=NULL_CHANNEL, bool blocking=true)
unsigned int | CopyRangeTo2 (BufferedTransformation &target, unsigned long &begin, unsigned long end=ULONG_MAX, const std::string &channel=NULL_CHANNEL, bool blocking=true) const
void | IsolatedInitialize (const NameValuePairs &parameters)
unsigned int | NumberOfMessages () const
| number of times MessageEnd() has been received minus messages retrieved or skipped
bool | GetNextMessage ()
| start retrieving the next message
unsigned int | CopyMessagesTo (BufferedTransformation &target, unsigned int count=UINT_MAX, const std::string &channel=NULL_CHANNEL) const
void | SetAutoSignalPropagation (int propagation)
int | GetAutoSignalPropagation () const
BufferedTransformation & | Ref ()
| return a reference to this object
virtual std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
virtual Clonable * | Clone () const
| this is not implemented by most classes yet
bool | Wait (unsigned long milliseconds)
| wait on this object
## Static Public Attributes
const std::string | NULL_CHANNEL
## Protected Member Functions
unsigned int | Put2 (const byte *begin, unsigned int length, int messageEnd, bool blocking)
bool | IsolatedFlush (bool, bool)
bool | IsolatedMessageSeriesEnd (bool)
unsigned int | ChannelPut2 (const std::string &channel, const byte *begin, unsigned int length, int messageEnd, bool blocking)
bool | ChannelMessageSeriesEnd (const std::string &, int, bool)
## Static Protected Member Functions
int | DecrementPropagation (int propagation)
## Protected Attributes
bool | m_messageEnd

## Member Function Documentation

unsigned long NullStore::MaxRetrievable | ( |  | ) | const`[inline, virtual]`

| returns number of bytes that is currently ready for retrieval All retrieval functions return the actual number of bytes retrieved, which is the lesser of the request number and MaxRetrievable(). Reimplemented from BufferedTransformation. Definition at line 591 of file filters.h.

bool Store::GetNextMessage | ( |  | ) | `[virtual, inherited]`

| start retrieving the next message Returns false if no more messages exist or this message is not completely retrieved. Reimplemented from BufferedTransformation. Definition at line 814 of file filters.cpp. References BufferedTransformation::AnyRetrievable().

BufferedTransformation& BufferedTransformation::Ref | ( |  | ) | `[inline, inherited]`

| return a reference to this object This function is useful for passing a temporary BufferedTransformation object to a function that takes a non-const reference. Definition at line 702 of file cryptlib.h.

virtual byte* BufferedTransformation::CreatePutSpace | ( | unsigned int & | size | ) | `[inline, virtual, inherited]`

  | request space to write bytes into for processing Parameters:
  size | is requested size (as a hint) for input, and size of the returned space for output
Reimplemented in HashFilter, ArraySink, ArrayXorSink, and ByteQueue. Definition at line 720 of file cryptlib.h. Referenced by ArrayXorSink::CreatePutSpace().

virtual unsigned int BufferedTransformation::PutModifiable2 | ( | byte * | inString,
|  | unsigned int | length,
|  | int | messageEnd,
|  | bool | blocking
| ) | `[inline, virtual, inherited]`

  | input multiple bytes that may be modified by callee for blocking or non-blocking processing Parameters:
  messageEnd | means how many filters to signal MessageEnd to, including this one
Reimplemented in FilterWithBufferedInput. Definition at line 738 of file cryptlib.h.

bool BufferedTransformation::Flush | ( | bool | hardFlush,
|  | int | propagation = -1,
|  | bool | blocking = true
| ) | `[virtual, inherited]`

  | flush buffered input and/or output Parameters:
  hardFlush | is used to indicate whether all data should be flushed
Note: Hard flushes must be used with care. It means try to process and output everything, even if there may not be enough data to complete the action. For example, hard flushing a HexDecoder would cause an error if you do it after inputing an odd number of hex encoded characters. For some types of filters, for example ZlibDecompressor, hard flushes can only be done at "synchronization points". These synchronization points are positions in the data stream that are created by hard flushes on the corresponding reverse filters, in this example ZlibCompressor. This is useful when zlib compressed data is moved across a network in packets and compression state is preserved across packets, as in the ssh2 protocol. Reimplemented in Filter, Redirector, SecretSharing, and InformationDispersal. Definition at line 169 of file cryptlib.cpp. References BufferedTransformation::AttachedTransformation().

bool BufferedTransformation::MessageSeriesEnd | ( | int | propagation = -1,
|  | bool | blocking = true
| ) | `[virtual, inherited]`

| mark end of a series of messages There should be a MessageEnd immediately before MessageSeriesEnd. Reimplemented in Filter, and Redirector. Definition at line 175 of file cryptlib.cpp. References BufferedTransformation::AttachedTransformation().

virtual bool BufferedTransformation::Attachable | ( |  | ) | `[inline, virtual, inherited]`

| returns whether this object allows attachment Some BufferedTransformation objects (e.g. Filter objects) allow other BufferedTransformation objects to be attached. When this is done, the first object instead of buffering its output, sents that output to the attached object as input. The entire attachment chain is deleted when the anchor object is destructed. Reimplemented in Filter. Definition at line 926 of file cryptlib.h. Referenced by BufferedTransformation::Attach().

bool Waitable::Wait | ( | unsigned long | milliseconds | ) | `[inherited]`

| wait on this object same as creating an empty container, calling GetWaitObjects(), and calling Wait() on the container Definition at line 101 of file wait.cpp. References Waitable::GetWaitObjects(), and WaitObjectContainer::Wait(). Referenced by NetworkSource::GeneralPump2(), and NetworkSink::TimedFlush().

The documentation for this class was generated from the following files:

- filters.h
- filters.cpp